using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DeliociIXOR
{
    internal class Program
    {
        static List<int> Delioci(int n)
        {
            var delioci = new List<int>();

            for(int i = 1; i <= n/2; i++)
            {
                if(n % i == 0) delioci.Add(i);
            }
            delioci.Add(n);
            return delioci;
        }

        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split(' ');
            int n = int.Parse(s[0]);
            int k = int.Parse(s[1]);

            s = Console.ReadLine().Split(' ');
            int[] d = new int[k];

            var delioci = new List<int>();

            for (int i = 0; i < k; i++)
            {
                d[i] = int.Parse(s[i]);
                delioci = Delioci(d[i]);
                int xor = 0;

                if (delioci.Count == 1) Console.Write(delioci[0] + " ");
                else
                {
                    foreach (var r in delioci)
                    {
                        xor = xor ^ r;
                    }
                    Console.Write(xor + " ");
                }
            }
        }
    }
}